Option Explicit On
Option Strict On


Imports System.Windows.Forms
Imports System.Runtime.InteropServices


'//////////////////////////////////////////////////////////////
''' <summary>
''' J(rfILv`foCX)I_CAOłB
''' o̓sAyсAtB^^s̃vpeBIł܂B
''' </summary>
''' <remarks></remarks>
Public Class DSUSelectCameraDialog

    '----------------------------------------------------------
    'Jf[^

    ''' <summary>JtB^\ȗꂽɐݒ肳閼̂łB</summary> 
    Public Const DEFAULTCAMERAFILTERCAPTION As String = "Camera"

    ''' <summary>
    ''' rfILv`OtɊւłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Structure VIDEOCAPTUREGRAPHINFO

        ''' <summary>ꂽOtłB</summary>
        Public Graph As IGraphBuilder

        ''' <summary>Iꂽ\[XtB^łB</summary>
        Public Filter As IBaseFilter

        ''' <summary>Iꂽ\[XtB^̖̂łB</summary>
        Public FilterName As String

        ''' <summary>\[XtB^̏o̓słB</summary>
        Public Pin As IPin

        ''' <summary>o̓ŝ̖łB</summary>
        Public PinName As String

        ''' <summary>IꂽtH[}bg`łB</summary>
        Public Format As FORMATINFORMATION

        ''' <summary>JtB^̕\łB</summary> 
        ''' <remarks>ȗ()DEFAULTCAMERAFILTERCAPTION̒lg܂B</remarks>
        Public FilterCaption As String

        '------------------------------------------------------

        ''' <summary>
        ''' OtCX^XAeoNA܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub Release()

            'Ot̉
            ReleaseInstance(Graph)

            'õNA
            Clear()

        End Sub

        ''' <summary>
        ''' eoNA܂B
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub Clear()
            Graph = Nothing
            Filter = Nothing
            Pin = Nothing
            Format = New FORMATINFORMATION
        End Sub

    End Structure

    '----------------------------------------------------------
    'f[^
    Private mDevList As New List(Of FILTERINFORMATION)  'foCXXg
    Private mPinList As New List(Of PININFORMATION)     'sXg
    Private mFmtList As New List(Of FORMATINFORMATION)  'tH[}bgXg
    Private mGrpInfo As VIDEOCAPTUREGRAPHINFO           'I𒆂̃Ot

    '----------------------------------------------------------
#Region "_CAO֌W"

    'tH[[h
    Private Sub DSUSelectCameraDialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    'OK{^
    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click

        '`FbN
        If (mGrpInfo.Filter Is Nothing) Or (mGrpInfo.Pin Is Nothing) Then
            MsgBox("foCXAyсAsIĉB", MsgBoxStyle.OkOnly, "J̑I")
            Exit Sub
        End If

        '
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()

    End Sub

    'LZ{^
    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    '_CAO\
    ''' <summary>
    ''' _CAO\܂B
    ''' </summary>
    ''' <param name="GraphInfo">Ot񂪊i[VIDEOCAPTUREGRAPHINFO\</param>
    ''' <returns>ɑIꂽꍇWindows.Forms.DialogResult.OԂ܂B</returns>
    ''' <remarks>w肵GraphInfo̊eoɃ_CAOőIꂽe񂪊i[܂B</remarks>
    Public Overloads Function ShowDialog(ByRef GraphInfo As VIDEOCAPTUREGRAPHINFO) As DialogResult

        Dim ret As DialogResult = Windows.Forms.DialogResult.Cancel
        Try

            'NA
            GraphInfo.Release()
            mGrpInfo.Release()

            'VOt
            mGrpInfo.Graph = CreateNewGraph()

            'e탊Xg̃NA
            ClearFilter()
            UpdateDeviceList()

            'I
            ret = MyBase.ShowDialog()
            If ret = Windows.Forms.DialogResult.OK Then

                'tH[}bg̑I
                SelectFormat()

                '߂lݒ
                GraphInfo = mGrpInfo

            End If

        Catch ex As Exception

            'G[bZ[W\
            ShowMessage(ex, "JIł܂B")
            ret = Windows.Forms.DialogResult.Cancel

        Finally

            'Еt
            mGrpInfo.Clear()

        End Try

        Return ret
    End Function

#End Region

    '----------------------------------------------------------
#Region "bZ[W\֌W"

    ''' <summary>
    ''' bZ[W\܂B
    ''' </summary>
    ''' <param name="Fmt">bZ[W</param>
    ''' <param name="Param">bZ[W</param>
    ''' <remarks></remarks>
    Private Sub ShowMessage(ByVal Fmt As String, ByVal ParamArray Param() As Object)
        MsgBox(String.Format(Fmt, Param), MsgBoxStyle.OkOnly, "J̑I")
    End Sub

    ''' <summary>
    ''' bZ[W\܂B
    ''' </summary>
    ''' <param name="ex">O</param>
    ''' <param name="Fmt">bZ[W</param>
    ''' <param name="Param">bZ[W</param>
    ''' <remarks></remarks>
    Private Sub ShowMessage(ByVal ex As Exception, ByVal Fmt As String, ByVal ParamArray Param() As Object)

        'bZ[WWJ
        Dim dse As DSException
        dse = New DSException(ex, Fmt, Param)

        '\
        MsgBox(dse.FullMessage, MsgBoxStyle.OkOnly, "J̑I")

    End Sub

#End Region

    '----------------------------------------------------------
#Region "foCXI֌W"

    ''' <summary>
    ''' tB^INA܂B
    ''' sI/tH[}bgAyсAs/tH[}bg̃R{{bNXNA܂B
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ClearFilter()

        'tB^Ot폜
        If mGrpInfo.Filter IsNot Nothing Then
            mGrpInfo.Graph.RemoveFilter(mGrpInfo.Filter)
        End If

        'tB^ĨNA
        mGrpInfo.Filter = Nothing

        's̃NA
        ClearPin()

        'sXg̃NA
        mPinList.Clear()
        Cmb_OutPin.Items.Clear()

    End Sub

    ''' <summary>
    ''' foCXXgXV܂B
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub UpdateDeviceList()

        Try

            'R{{bNX̃NA
            Cmb_Device.Items.Clear()

            'rfILv`tB^̗
            mDevList = EnumFilters(DSConst.FilterCategoryGUID.CLSID_VideoInputDeviceCategory)

            'R{{bNX̏
            For x As Integer = 0 To mDevList.Count - 1
                Cmb_Device.Items.Add(mDevList(x).Name)
            Next

        Catch ex As Exception
            Throw New DSException(ex, "foCXꗗ̎擾Ɏs܂B")

        End Try

    End Sub

    ''' <summary>
    ''' foCXȈłB
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Cmb_Device_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cmb_Device.SelectedIndexChanged

        Try
            'Iꂽԍ擾
            Dim idx As Integer = Cmb_Device.SelectedIndex
            If idx < 0 Then Exit Sub

            '݂̑ItB^NA
            ClearFilter()

            'IꂽtB^Otɒǉ
            If mGrpInfo.FilterCaption = "" Then mGrpInfo.FilterCaption = DEFAULTCAMERAFILTERCAPTION
            mGrpInfo.Filter = AddFilter(mGrpInfo.Graph, DSConst.FilterCategoryGUID.CLSID_VideoInputDeviceCategory, mDevList(idx).Name, mDevList(idx).Index, mGrpInfo.FilterCaption)
            mGrpInfo.FilterName = mDevList(idx).Name

            's̑I
            UpdatePinList()
            If mPinList.Count = 0 Then Throw New DSException("pło̓s܂B")

            '擪̃sI
            Cmb_OutPin.SelectedIndex = 0

        Catch ex As Exception

            'G[bZ[W\
            ShowMessage(ex, "IꂽfoCX͎gpł܂B")

            'NA
            ClearFilter()
            Cmb_Device.SelectedIndex = -1

        End Try

    End Sub

    ''' <summary>
    ''' foCXvpeB{^̏łB
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Btn_Device_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Device.Click

        'foCXIĂ邩mF
        If mGrpInfo.Filter Is Nothing Then
            MsgBox("foCXIĉB")
            Exit Sub
        End If

        'vpeBy[W\
        If OpenPropertyDialog(mGrpInfo.Filter, Me.Handle, "foCX") Then
            MsgBox("vpeBy[WȂAݗpł܂B")
            Exit Sub
        End If

        's̃NA
        ClearPin()
        Cmb_OutPin.SelectedIndex = -1

    End Sub

#End Region

    '----------------------------------------------------------
#Region "sI֌W"

    ''' <summary>
    ''' sINA܂B
    ''' tH[}bgIAyсAtH[}bg̃R{{bNXNA܂B
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ClearPin()

        's̃NA
        mGrpInfo.Pin = Nothing

        'tH[}bgXg̃NA
        mFmtList.Clear()
        Cmb_Format.Items.Clear()

    End Sub

    ''' <summary>
    ''' sXgXV܂B
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub UpdatePinList()

        Try
            'R{{bNX̃NA
            Cmb_OutPin.Items.Clear()

            'tB^IĂ邩H
            If mGrpInfo.Filter Is Nothing Then Exit Sub

            's̗
            mPinList = EnumPins(mGrpInfo.Filter)

            'o̓sȊOO
            For x As Integer = mPinList.Count - 1 To 0 Step -1
                If mPinList(x).Direction <> PIN_DIRECTION.PINDIR_OUTPUT Then
                    'O
                    mPinList.RemoveAt(x)
                End If
            Next

            'R{{bNX̏
            For x As Integer = 0 To mPinList.Count - 1
                Cmb_OutPin.Items.Add(mPinList(x).Name)
            Next

        Catch ex As Exception
            Throw New DSException(ex, "sꗗ̎擾Ɏs܂B")

        End Try

    End Sub

    ''' <summary>
    ''' sȈłB
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Cmb_OutPin_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cmb_OutPin.SelectedIndexChanged

        Try
            '`FbN
            If mGrpInfo.Filter Is Nothing Then Exit Sub

            'Iꂽԍ擾
            Dim idx As Integer = Cmb_OutPin.SelectedIndex
            If idx < 0 Then Exit Sub

            '݂̑IsNA
            ClearPin()

            's̎擾
            mGrpInfo.Pin = FindPin(mGrpInfo.Filter, mPinList(idx).Name)
            mGrpInfo.PinName = mPinList(idx).Name

            'tH[}bg̑I
            UpdateFormatList()

        Catch ex As Exception

            'G[bZ[W\
            ShowMessage(ex, "Iꂽs͎gpł܂B")

            'NA
            ClearFilter()
            Cmb_Device.SelectedIndex = -1

        End Try

    End Sub

    ''' <summary>
    ''' svpeB{^̏łB
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Btn_OutPin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_OutPin.Click

        'sIĂ邩mF
        If mGrpInfo.Pin Is Nothing Then
            MsgBox("sIĉB")
            Exit Sub
        End If

        'vpeBy[W\
        If OpenPropertyDialog(mGrpInfo.Pin, Me.Handle, "s") Then
            MsgBox("vpeBy[WȂAݗpł܂B")
            Exit Sub
        End If

        'tH[}bg̃NA
        UpdateFormatList()

    End Sub

#End Region

    '----------------------------------------------------------
#Region "tH[}bgI֌W"

    ''' <summary>
    ''' tH[}bgXgXV܂B
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub UpdateFormatList()

        Try

            'R{{bNX̃NA
            Cmb_Format.Items.Clear()

            'sIĂ邩H
            If mGrpInfo.Pin Is Nothing Then Exit Sub

            '݂̃tH[}bg擾
            Dim fmt As AM_MEDIA_TYPE = GetFormat(mGrpInfo.Pin)
            Dim vinfo As DSVIDEOINFOHEADER
            vinfo = PtrToStructure(Of DSVIDEOINFOHEADER)(fmt.formatPtr)

            'tH[}bg̗
            mFmtList = EnumFormat(mGrpInfo.Pin)

            'R{{bNX̏
            For x As Integer = 0 To mFmtList.Count - 1
                With mFmtList(x)

                    '\ڂ̍쐬
                    Dim ss As New System.Text.StringBuilder
                    ss.AppendFormat("{0} : ", GetMediaTypeName(.SubType.ToString))
                    If CompGUIDString(.FormatType.ToString, DSConst.FormatTypeGUID.FORMAT_VideoInfo) Then
                        'T|[g摜`
                        ss.AppendFormat("{0} x {1}", .VideoSize.Width, .VideoSize.Height)
                    Else
                        ss.AppendFormat("Unknown format")
                    End If

                    'R{{bNXɒǉ
                    Cmb_Format.Items.Add(ss.ToString)

                    '݂̃tH[}bgH
                    If .MajorType.Equals(fmt.majorType) Then
                        If .SubType.Equals(fmt.subType) Then
                            If .FormatType.Equals(fmt.formatType) Then
                                If (.VideoSize.Width = vinfo.BmiHeader.Width) And (.VideoSize.Height = vinfo.BmiHeader.Height) Then
                                    '݂̃tH[}bgł

                                    'I
                                    Cmb_Format.SelectedIndex = x
                                End If
                            End If
                        End If
                    End If
                End With
            Next

        Catch ex As Exception

            'bZ[W\
            ShowMessage(ex, "tH[}bg̎擾Ɏs܂BtH[}bg͑Ił܂B")

            'NA
            Cmb_Format.Items.Clear()

        End Try

    End Sub

    ''' <summary>
    ''' IꂽtH[}bgݒ肵܂B
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SelectFormat()

        Try
            '`FbN
            If mGrpInfo.Filter Is Nothing Then Exit Sub
            If mGrpInfo.Pin Is Nothing Then Exit Sub

            'Iꂽԍ擾
            Dim idx As Integer = Cmb_Format.SelectedIndex
            If idx < 0 Then Exit Sub 'tH[}bgI

            Dim fmt As FORMATINFORMATION = mFmtList(idx)

            'IAMStreamConfig擾
            Dim cfg As IAMStreamConfig
            cfg = TryCast(mGrpInfo.Pin, IAMStreamConfig)
            If cfg Is Nothing Then Throw New DSException("IAMStreamConfigC^[tF[X擾ł܂B")

            '݂̃tH[}bg擾
            Dim mt As New AM_MEDIA_TYPE
            cfg.GetFormat(mt)
            Dim vinfo As New DSVIDEOINFOHEADER
            vinfo = PtrToStructure(Of DSVIDEOINFOHEADER)(mt.formatPtr)

            'TCYƃtH[}bg^CvύX
            vinfo.BmiHeader.Width = Fmt.VideoSize.Width
            vinfo.BmiHeader.Height = Fmt.VideoSize.Height
            Marshal.StructureToPtr(vinfo, mt.formatPtr, True)
            mt.formatType = Fmt.FormatType
            cfg.SetFormat(mt)

        Catch ex As Exception
            Throw New DSException(ex, "tH[}bg̐ݒɎs܂B")

        End Try

    End Sub

    ''' <summary>
    ''' tH[}bgI{^̏łB
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Btn_FormatClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_FormatClear.Click

        Cmb_Format.SelectedIndex = -1

    End Sub


#End Region


End Class
