Option Explicit On
Option Strict On

'//////////////////////////////////////////////////////////////
'DShowLib@Tv@StreamBuffer
'EXg[obt@GWgTvłB
'Evr[Jn{^Ńvr[\JnA
'@^JnŎw肳ꂽtH_ɓt@Cۑ܂B
'Eۑ铮t@C͖kAVIłB
'@HDDeʂɒӂĉB
'ẼTvWindowsXP-SP1ȍ~ł삵܂B
'EXg[obt@GWMPEG2DVT|[gĂ܂B
'@̈׏o̓TCYDVTCYɂȂĂ܂B
'//////////////////////////////////////////////////////////////

'DirectShowNXCu
Imports DShowLib
Imports System.Runtime.InteropServices
Imports Microsoft.Win32


Public Class Form1

    'W[ϐ

    Private mGrpSink As IGraphBuilder       'VNOtiLv`pOtj
    Private mSBESink As IStreamBufferSink   'VNtB^
    Private mGrpPreview As IGraphBuilder    '\[XOtivr[pOtj
    Private mGrpRecord As IGraphBuilder     '\[XOtiL^pOtj

    '----------------------------------------------------------

    'tH[[h
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    'tH[N[Y
    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'L^pOt̔j
        DestroyRecordGraph()

        'vr[Ot̔j
        DestroyPreviewGraph()

        'VNOt̔j
        DestroySinkGraph()

    End Sub

    '----------------------------------------------------------

    'vr[Jn{^
    Private Sub Btn_PreviewStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_PreviewStart.Click

        'VNOt쐬
        CreateSinkGraph()
        If mGrpSink Is Nothing Then Exit Sub

        'vr[Ot쐬
        CreatePreviewGraph()

        'VNOtJn
        GraphPlay(mGrpSink)

        'vr[OtJn
        GraphPlay(mGrpPreview)

    End Sub

    'vr[I{^
    Private Sub Btn_PreviewEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_PreviewEnd.Click

        'vr[Ot̔j
        DestroyPreviewGraph()

        'VNOtj
        DestroySinkGraph()

    End Sub

    '^Jn{^
    Private Sub Btn_RecordStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_RecordStart.Click

        'ۑt@Č
        Dim fname As String = Txt_File.Text
        If (fname <> "") AndAlso (Not fname.EndsWith("\")) Then fname += "\"
        fname += Format(Now, "yyyyMMddHHmmss") + ".avi"

        'L^pOt쐬
        CreateRecordGraph(fname)

        'L^pOtJn
        GraphPlay(mGrpRecord)

        'L^t@C̕\
        Lbl_File.Text = fname

    End Sub

    '^I{^
    Private Sub Btn_RecordEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_RecordEnd.Click

        'L^pOtj
        DestroyRecordGraph()

    End Sub

    '----------------------------------------------------------

    'VNOt̍쐬
    Private Sub CreateSinkGraph()

        'NA
        DestroySinkGraph()

        'JI
        Dim dlg As New DSUSelectCameraDialog
        Dim grpinfo As New DSUSelectCameraDialog.VIDEOCAPTUREGRAPHINFO
        If dlg.ShowDialog(grpinfo) <> Windows.Forms.DialogResult.OK Then Exit Sub

        'Xg[obt@VNtB^Otɒǉ
        Dim sbsflt As IBaseFilter = AddFilter(grpinfo.Graph, DSConst.FilterGUID.CLSID_StreamBufferSink)

        'DVGR[_tB^Otɒǉ
        Dim dveflt As IBaseFilter = AddFilter(grpinfo.Graph, DSConst.FilterGUID.CLSID_DVVideoEnc)

        'JtB^̏o̓s#0DVGR[_tB^ڑ
        Dim dveipin As IPin = FindPin(dveflt, 0, PIN_DIRECTION.PINDIR_INPUT)
        grpinfo.Graph.Connect(grpinfo.Pin, dveipin)

        'DVGR[_tB^ƃXg[obt@VNtB^ڑ
        Dim dveopin As IPin = FindPin(dveflt, 0, PIN_DIRECTION.PINDIR_OUTPUT)    'DVGR[_tB^̏o̓s
        Dim sbsipin As IPin = FindPin(sbsflt, 0, PIN_DIRECTION.PINDIR_INPUT)    'Xg[obt@VNtB^̓̓s
        grpinfo.Graph.Connect(dveopin, sbsipin)

        'IStreamBufferSinkC^[tF[X擾
        mSBESink = CType(sbsflt, IStreamBufferSink)

        'vt@C̃bN
        mSBESink.LockProfile(vbNullString)
        'mSBESink.LockProfile("m:\iran")    'fobOp

        'Ot
        mGrpSink = grpinfo.Graph

    End Sub

    'VNOt̔j
    Private Sub DestroySinkGraph()

        'Ot~
        GraphStop(mGrpSink)

        'J
        ReleaseInstance(mGrpSink)

    End Sub

    '----------------------------------------------------------

    'vr[pOt̍쐬
    Private Sub CreatePreviewGraph()

        'NA
        DestroyPreviewGraph()

        'VOt쐬
        mGrpPreview = CreateNewGraph()

        'Xg[obt@\[XtB^ǉ
        Dim srcflt As IBaseFilter = AddFilter(mGrpPreview, DSConst.FilterGUID.CLSID_StreamBufferSource)

        'IStreamBufferSourceC^[tF[X擾
        Dim sbesrc As IStreamBufferSource = CType(srcflt, IStreamBufferSource)

        'VNtB^̐ݒ
        sbesrc.SetStreamSink(msbesink)

        'DVfR[_tB^ǉ
        Dim dvflt As IBaseFilter = AddFilter(mGrpPreview, DSConst.FilterGUID.CLSID_DVVideoDecoder)

        '_܂Őڑ
        mGrpPreview.Render(FindPin(srcflt, 0, PIN_DIRECTION.PINDIR_OUTPUT))

    End Sub

    'vr[pOt̔j
    Private Sub DestroyPreviewGraph()

        'Ot~
        GraphStop(mGrpPreview)

        'J
        ReleaseInstance(mGrpPreview)

    End Sub

    '----------------------------------------------------------

    'L^pOt̍쐬
    Private Sub CreateRecordGraph(ByVal Filename As String)

        'NA
        DestroyRecordGraph()

        'VOt쐬
        mGrpRecord = CreateNewGraph()

        'Xg[obt@\[XtB^ǉ
        Dim srcflt As IBaseFilter = AddFilter(mGrpRecord, DSConst.FilterGUID.CLSID_StreamBufferSource)

        'IStreamBufferSourceC^[tF[X擾
        Dim sbesrc As IStreamBufferSource = CType(srcflt, IStreamBufferSource)

        'VNtB^̐ݒ
        sbesrc.SetStreamSink(mSBESink)

        'DVfR[_tB^ǉ
        Dim dvdecflt As IBaseFilter = AddFilter(mGrpRecord, DSConst.FilterGUID.CLSID_DVVideoDecoder)

        '\[XtB^DVfR[_tB^ǉ
        Dim spin As IPin = FindPin(srcflt, 0, PIN_DIRECTION.PINDIR_OUTPUT)
        Dim dpin As IPin = FindPin(dvdecflt, 0, PIN_DIRECTION.PINDIR_INPUT)
        mGrpRecord.Connect(spin, dpin)

        'AVI MuxtB^ǉ
        Dim muxflt As IBaseFilter = AddFilter(mGrpRecord, FilterGUID.CLSID_AVIMux)

        'FileWritertB^ǉ
        Dim wrtflt As IBaseFilter = AddFilter(mGrpRecord, FilterGUID.CLSID_Filewriter)

        'IFileSinkFilterC^[tF[X擾
        Dim snkflt As IFileSinkFilter = TryCast(wrtflt, IFileSinkFilter)

        't@Cݒ
        snkflt.SetFileName(Filename, Nothing)

        'tB^ڑ
        mGrpRecord.Render(FindPin(dvdecflt, 0, PIN_DIRECTION.PINDIR_OUTPUT))

        'JnƍŏI擾
        Dim sek As IStreamBufferMediaSeeking = CType(srcflt, IStreamBufferMediaSeeking)
        Dim contentstart As Long
        Dim contentstop As Long
        sek.GetAvailable(contentstart, contentstop)

        'ŏIʒuĐ悤ɂ
        sek.SetPositions(contentstop, AM_SEEKING_SEEKING_FLAGS.AM_SEEKING_AbsolutePositioning, 0, AM_SEEKING_SEEKING_FLAGS.AM_SEEKING_NoPositioning)

    End Sub

    'L^pOt̔j
    Private Sub DestroyRecordGraph()

        'ۑt@C̃NA
        Lbl_File.Text = ""

        'Ot~
        GraphStop(mGrpRecord)

        'J
        ReleaseInstance(mGrpRecord)

    End Sub

End Class
